/**
  * Webcore Web Engine Abstraction Layer.
  * @file gwebcoreengine.h: Webcore Web Engine Interface Declaration
  * @version $Rev: 2101 $
  * @date $LastChangedDate: 2005-11-02 16:35:49 +0300 (Срд, 02 Ноя 2005) $
  *
  * Copyright (C) 2005 Nokia Corporation.
  *
  * Contact: Leonid Zolotarev <leonid.zolotarev@nokia.com>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
  * as published by the Free Software Foundation; either version 2.1 of
  * the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA
  *
  */

#include <gwebengine.h>

#include "gtk-khtml.h"
#include "webi.h"
//#include "gtkmozembed_internal.h"

#ifndef __GWEBCOREENGINE_H__
#define __GWEBCOREENGINE_H__

void
gtk_marshal_VOID__INT_INT_BOOL  (GClosure     *closure,
                                 GValue      *return_value,
                                 guint        n_param_values,
                                 const GValue *param_values,
                                 gpointer      invocation_hint,
                                 gpointer      marshal_data);


G_BEGIN_DECLS

#define G_TYPE_WEBCORE_ENGINE           (g_webcore_engine_get_type ())
#define G_WEBCORE_ENGINE(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_TYPE_WEBCORE_ENGINE, GWebcoreEngine))
#define G_WEBCORE_ENGINE_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST ((klass), G_TYPE_WEBCORE_ENGINE, GWebcoreEngineClass))
#define G_IS_WEBCORE_ENGINE(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_TYPE_WEBCORE_ENGINE))
#define G_IS_WEBCORE_ENGINE_CLASS(klass)        (G_TYPE_CHECK_CLASS_TYPE ((klass), G_TYPE_WEBCORE_ENGINE))
#define G_WEBCORE_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_TYPE_WEBCORE_ENGINE, GWebcoreEngineClass))

typedef struct _GWebcoreEngine GWebcoreEngine;
typedef struct _GWebcoreEngineClass GWebcoreEngineClass;

struct _GWebcoreEngine
{
    GtkKHTML parent;
    GObject* engine;
    gint current_zoom;
    gboolean _can_focus;
    GtkIMContext * im_context;
    guint timer_id;
    //    GContextData ctx_data;
};

struct _GWebcoreEngineClass
{
    GtkKHTMLClass parent_class;
    void (*load_stop)		(GWebcoreEngine *embed);
    void (*load_start)		(GWebcoreEngine *embed);
    void (*location)		(GWebcoreEngine *embed);
    void (*title)		(GWebcoreEngine *embed);
//    void (*progress_all)	(GWebcoreEngine *embed);
    void (*progress)		(GWebcoreEngine *embed);
//    void (*status)		(GWebcoreEngine *embed);
    //    void (*destroy_brsr)	(GWebcoreEngine *embed);
    //    void (*popup_menu)		(GWebcoreEngine *embed);
    //    void (*window_request)	(GWebcoreEngine *embed);
    //    void (*input_activate)	(GWebcoreEngine *embed);
    //    void (*input_deactivate)	(GWebcoreEngine *embed);
};

GType g_webcore_engine_get_type (void);

static GWebcoreEngine *cur_engine;

GObject* g_webcore_engine_new                         (void);
GObject* g_webcore_engine_new_window		      (GWebcoreEngine *);
GObject* g_webcore_engine_new_with_context            (gpointer context);
GObject* g_webcore_engine_new_with_context_and_tracks (gpointer context, gboolean leave_tracks);

G_END_DECLS

#endif /* __GWEBCOREENGINE_H__ */
