/**
  * Webcore Web Engine Abstraction Layer.
  * @file gwebcorehistorylist.h: Webcore History List Interface Declaration
  * @version $Rev: 2101 $
  * @date $LastChangedDate: 2005-11-02 16:35:49 +0300 (Срд, 02 Ноя 2005) $
  *
  * Copyright (C) 2005 Nokia Corporation.
  *
  * Contact: Leonid Zolotarev <leonid.zolotarev@nokia.com>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
  * as published by the Free Software Foundation; either version 2.1 of
  * the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA
  *
  */

#include <gwebhistorylist.h>

#ifndef __GWEBCOREHISTORYLIST_H__
#define __GWEBCOREHISTORYLIST_H__

G_BEGIN_DECLS

/* GWebcoreHistoryList */

#define G_TYPE_WEBCORE_HISTORY_LIST             (g_webcore_history_list_get_type ())
#define G_WEBCORE_HISTORY_LIST(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_TYPE_WEBCORE_HISTORY_LIST, GWebcoreHistoryList))
#define G_WEBCORE_HISTORY_LIST_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), G_TYPE_WEBCORE_HISTORY_LIST, GWebcoreHistoryListClass))
#define G_IS_WEBCORE_HISTORY_LIST(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_TYPE_WEBCORE_HISTORY_LIST))
#define G_IS_WEBCORE_HISTORY_LIST_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), G_TYPE_WEBCORE_HISTORY_LIST))
#define G_WEBCORE_HISTORY_LIST_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_INTERFACE ((inst), G_TYPE_WEBCORE_HISTORY_LIST, GWebcoreHistoryListClass))

typedef struct _GWebcoreHistoryList GWebcoreHistoryList;
typedef struct _GWebcoreHistoryListClass GWebcoreHistoryListClass;

struct _GWebcoreHistoryList
{
    GObject parent;

    GObject *items;
    gint num_items;
};

struct _GWebcoreHistoryListClass
{
    GObjectClass parent;
};

GType g_webcore_history_list_get_type (void);

GObject* g_webcore_history_list_new (void);

G_END_DECLS

#endif /* __GWEBCOREHISTORYLIST_H__ */
