/**
  * Webcore Web Engine Abstraction Layer.
  * @file gwebcoretransferitem.h: Webcore Transfer Item Interface Declaration
  * @version $Rev: 2101 $
  * @date $LastChangedDate: 2005-11-02 16:35:49 +0300 (Срд, 02 Ноя 2005) $
  *
  * Copyright (C) 2005 Nokia Corporation.
  *
  * Contact: Leonid Zolotarev <leonid.zolotarev@nokia.com>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
  * as published by the Free Software Foundation; either version 2.1 of
  * the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA
  *
  */

#include <gwebtransferitem.h>

#ifndef __GWEBCORETRANSFERITEM_H__
#define __GWEBCORETRANSFERITEM_H__

G_BEGIN_DECLS

#define G_TYPE_WEBCORE_TRANSFER_ITEM             (g_webcore_transfer_item_get_type ())
#define G_WEBCORE_TRANSFER_ITEM(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_TYPE_WEBCORE_TRANSFER_ITEM, GWebcoreTransferItem))
#define G_WEBCORE_TRANSFER_ITEM_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), G_TYPE_WEBCORE_TRANSFER_ITEM, GWebcoreTransferItemClass))
#define G_IS_WEBCORE_TRANSFER_ITEM(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_TYPE_WEBCORE_TRANSFER_ITEM))
#define G_IS_WEBCORE_TRANSFER_ITEM_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), G_TYPE_WEBCORE_TRANSFER_ITEM))
#define G_WEBCORE_TRANSFER_ITEM_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_INTERFACE ((inst), G_TYPE_WEBCORE_TRANSFER_ITEM, GWebcoreTransferItemClass))

typedef struct _GWebcoreTransferItem GWebcoreTransferItem;
typedef struct _GWebcoreTransferItemClass GWebcoreTransferItemClass;

struct _GWebcoreTransferItem
{
    GObject parent;
    GObject* item;
};

struct _GWebcoreTransferItemClass
{
    GObjectClass parent;
};

GType g_webcore_transfer_item_get_type (void);

GObject* g_webcore_transfer_item_new           (void);
GObject* g_webcore_transfer_item_new_with_item (GObject *item);
GObject* g_webcore_transfer_item_new_with_url  (const gchar *url,
        const gchar *filename);

G_END_DECLS

#endif /* __GWEBCORETRANSFERITEM_H__ */
