/**
  * Webcore Web Engine Abstraction Layer.
  * @file gwebcoreweb.h: Webcore Web Objects Interface Declarations
  * @version $Rev: 2101 $
  * @date $LastChangedDate: 2005-11-02 15:35:49 +0200 (Wed, 02 Nov 2005) $
  *
  * Copyright (C) 2005 Nokia Corporation.
  *
  * Contact: Leonid Zolotarev <leonid.zolotarev@nokia.com>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
  * as published by the Free Software Foundation; either version 2.1 of
  * the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA
  *
  */

#include <gweb.h>

#ifndef __GWEBCOREWEB_H__
#define __GWEBCOREWEB_H__

G_BEGIN_DECLS

/* GWebcoreWeb */

#define G_TYPE_WEBCORE_WEB             (g_webcore_web_get_type ())
#define G_WEBCORE_WEB(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_TYPE_WEBCORE_WEB, GWebcoreWeb))
#define G_WEBCORE_WEB_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST ((vtable), G_TYPE_WEBCORE_WEB, GWebcoreWebClass))
#define G_IS_WEBCORE_WEB(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_TYPE_WEBCORE_WEB))
#define G_IS_WEBCORE_WEB_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE ((vtable), G_TYPE_WEBCORE_WEB))
#define G_WEBCORE_WEB_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_INTERFACE ((inst), G_TYPE_WEBCORE_WEB, GWebcoreWebClass))

typedef struct _GWebcoreWeb GWebcoreWeb;
typedef struct _GWebcoreWebClass GWebcoreWebClass;

struct _GWebcoreWeb
{
    GObject parent;

    GObject *global;
};

struct _GWebcoreWebClass
{
    GObjectClass parent;
};

GType g_webcore_web_get_type (void);

G_END_DECLS

#endif /* __GWEBCOREWEB_H__ */
