/**
  * Webcore Web Engine Abstraction Layer.
  * @file gwebcorehistorylist.c: Webcore History List Interface Implementation
  * @version $Rev: 2101 $
  * @date $LastChangedDate: 2005-11-02 16:35:49 +0300 (Срд, 02 Ноя 2005) $
  *
  * Copyright (C) 2005 Nokia Corporation.
  *
  * Contact: Leonid Zolotarev <leonid.zolotarev@nokia.com>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
  * as published by the Free Software Foundation; either version 2.1 of
  * the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA
  *
  */

#include "gwebcorehistorylist.h"

/* GWebcoreHistoryList */

static void
g_webcore_history_list_destroy (GWebcoreHistoryList *self)
{}

static void
g_webcore_history_list_delete_item (GWebcoreHistoryList *self, GObject *item)
{}

static GObject*
g_webcore_history_list_get_items (GWebcoreHistoryList *self)
{
    return G_WEBCORE_HISTORY_LIST(self)->items;
}

static gint
g_webcore_history_list_get_items_count (GWebcoreHistoryList *self)
{}

static gboolean
g_webcore_history_list_position_ok (GWebHistoryList *self, gint pos)
{}

static const gchar*
g_webcore_history_list_get_item_title (GWebHistoryList *self, gint pos)
{}

static const gchar*
g_webcore_history_list_get_item_url (GWebHistoryList *self, gint pos)
{}

static GTime
g_webcore_history_list_get_item_time (GWebHistoryList *self, gint pos)
{}

static void
g_webcore_history_list_interface_init (GWebHistoryListIface *iface)
{
    iface->destroy         = (void (*) (GWebHistoryList*))
                             g_webcore_history_list_destroy;
    iface->delete_item     = (void (*) (GWebHistoryList*, GObject*))
                             g_webcore_history_list_delete_item;
    iface->get_items       = (GObject* (*) (GWebHistoryList*))
                             g_webcore_history_list_get_items;
    iface->get_items_count = (gint (*) (GWebHistoryList*))
                             g_webcore_history_list_get_items_count;
    iface->get_item_title  = (const gchar* (*) (GWebHistoryList*, gint))
                             g_webcore_history_list_get_item_title;
    iface->get_item_url    = (const gchar* (*) (GWebHistoryList*, gint))
                             g_webcore_history_list_get_item_url;
    iface->get_item_time   = (GTime (*) (GWebHistoryList*, gint))
                             g_webcore_history_list_get_item_time;
}

static void
g_webcore_history_list_instance_init (GTypeInstance *instance, gpointer  g_class)
{
    G_WEBCORE_HISTORY_LIST(instance)->items     = NULL;
    G_WEBCORE_HISTORY_LIST(instance)->num_items = 0;
}

GType
g_webcore_history_list_get_type (void)
{
    static GType type = 0;
    if (type == 0)
    {
        static const GTypeInfo info =
            {
                sizeof (GWebcoreHistoryListClass),
                NULL,   /* base_init */
                NULL,   /* base_finalize */
                NULL,   /* class_init */
                NULL,   /* class_finalize */
                NULL,   /* class_data */
                sizeof (GWebcoreHistoryList),
                0,      /* n_preallocs */
                g_webcore_history_list_instance_init    /* instance_init */
            };
        static const GInterfaceInfo iface_info =
            {
                (GInterfaceInitFunc) g_webcore_history_list_interface_init,
                NULL,   /* interface_finalize */
                NULL    /* interface_data */
            };
        type = g_type_register_static (G_TYPE_OBJECT,
                                       "GWebcoreHistoryList",
                                       &info, (GTypeFlags) 0);
        g_type_add_interface_static (type,
                                     G_TYPE_WEB_HISTORY_LIST,
                                     &iface_info);
    }
    return type;
}

GObject*
g_webcore_history_list_new (void)
{

    GObject* instance = G_OBJECT(g_object_new(g_webcore_history_list_get_type(), NULL));
    //    	G_WEBCORE_HISTORY_LIST(instance)->num_items = gtk_webcore_web_get_history_list((GtkWebHistoryItem**)&G_WEBCORE_HISTORY_LIST(instance)->items);
    return instance;
}
