/**
  * Webcore Web Engine Abstraction Layer.
  * @file gwebcoreweb.c: Webcore Web Objects Interface Implementation
  * @version $Rev: 2101 $
  * @date $LastChangedDate: 2005-11-02 09:35:49 -0400 (Wed, 02 Nov 2005) $
  *
  * Copyright (C) 2005 Nokia Corporation.
  *
  * Contact: Leonid Zolotarev <leonid.zolotarev@nokia.com>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public License
  * as published by the Free Software Foundation; either version 2.1 of
  * the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
  * 02110-1301 USA
  *
  */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "gwebcoreweb.h"
#include "gwebcoreengine.h"
#include "gwebcoretransferitem.h"
#include "gwebcoretransferitemlist.h"
#include "gwebcorehistorylist.h"
#include "gwebcorepluginlist.h"
//#include "gtkwebcore.h"
//#include "gwebcoresupport.h"
#ifdef USE_OSSOLOG
#include <osso-log.h>
#endif

//extern ConfigData *config;

static void
g_webcore_web_show_error (const char *message)
{
#ifdef USE_OSSOLOG
    ULOG_ERR(message);
#endif
}

static void
g_webcore_web_destroy (GWebcoreWeb *self)
{}

static GWebEngine*
g_webcore_web_new_web_engine_window (GWebcoreWeb *self)
{

    return G_WEB_ENGINE(g_webcore_engine_new());
}

static GWebEngine*
g_webcore_web_new_web_engine_window_with_context (GWebcoreWeb *self, gpointer context, gboolean leave_tracks, gboolean without_history)
{
    /* THIS IS AN ATTEMPTIVE OF FIXING IT :)*/
    return G_WEB_ENGINE(g_webcore_engine_new_with_context (context));
}

static GWebTransferItem*
g_webcore_web_new_web_transfer_item (GWebcoreWeb *self, const gchar* url, const gchar* filename)
{
    return G_WEB_TRANSFER_ITEM(g_webcore_transfer_item_new_with_url(url, filename));
}

static GWebTransferItem*
g_webcore_web_initialize_web_transfer_item (GWebcoreWeb *self, GObject *web_transfer_item)
{
    return G_WEB_TRANSFER_ITEM(g_webcore_transfer_item_new_with_item(web_transfer_item));
}

static GWebTransferItemList*
g_webcore_web_get_web_transfer_item_list (GWebcoreWeb *self)
{
    return G_WEB_TRANSFER_ITEM_LIST(g_webcore_transfer_item_list_new());
}

void
g_webcore_web_set_home_page (GWebcoreWeb *self, const gchar* home_page)
{
    //    config->home=(gchar*)home_page;
    //    write_config();
}

static gchar*
g_webcore_web_get_home_page (GWebcoreWeb *self)
{
    gchar *home_page;
    //    self->global = cur_engine->engine;
    //    home_page = gtk_webcore_get_home_page (GTK_WIDGET(self->global));
    return home_page;

    //    return config->home;
}


static gint
g_webcore_web_get_maximum_cache_size (GWebcoreWeb *self)
{}

static gchar*
g_webcore_web_get_default_home_page (GWebcoreWeb *self)
{
    //return config->home;
    return NULL;
}

void
g_webcore_web_home_page_set (GWebcoreWeb *self)
{
    //    write_config();
}

static void
g_webcore_web_set_frame_borders_enabled (GWebcoreWeb *self, gboolean enabled)
{}

static gboolean
g_webcore_web_get_frame_borders_enabled (GWebcoreWeb *self)
{}

void
g_webcore_web_set_location_completion_suffixes (GWebcoreWeb *self, const gchar* suffixes)
{
    //    config->web_suffix = (gchar*)suffixes;
    //    write_config();
}

static gchar*
g_webcore_web_get_location_completion_suffixes (GWebcoreWeb *self)
{
    return NULL;// config->web_suffix;
}

static GWebStatus
g_webcore_web_set_plugins_enabled (GWebcoreWeb *self, gboolean enabled)
{}

void
g_webcore_web_set_ssl2_support (GWebcoreWeb *self, gboolean enabled)
{
    //    config->enable_ssl2=enabled;
    //    write_config();
}

static gboolean
g_webcore_web_get_ssl2_support (GWebcoreWeb *self)
{
    return FALSE;// config->enable_ssl2;
}

static gboolean
g_webcore_web_get_plugins_enabled (GWebcoreWeb *self)
{}

void
g_webcore_web_set_js_enabled (GWebcoreWeb *self, gboolean enabled)
{
    //    config->javascript=enabled;
    //    write_config();
}

static gboolean
g_webcore_web_get_js_enabled (GWebcoreWeb *self)
{
    return FALSE; //config->javascript;
}

static void
g_webcore_web_show_memory_cache_error (const char *message)
{
#ifdef USE_OSSOLOG
    ULOG_ERR(message);
#endif

    g_print("[CACHE] %s\n",message);
}

static void
g_webcore_web_set_memory_cache (GWebcoreWeb *self, GMemoryCache acceptance)
{
    /*    gint automatic = 0;
     
        switch (acceptance)
        {
        case G_MEMORY_CACHE_AUTOMATIC:
            automatic = 1;
            config->memCache = 256;
            break;
        case G_MEMORY_CACHE_OFF:
            config->memCache = 0;
            break;
        case G_MEMORY_CACHE_SMALL:
            config->memCache = 512;
            break;
        case G_MEMORY_CACHE_MEDIUM:
            config->memCache = 1024;
            break;
        case G_MEMORY_CACHE_DEFAULT:
            config->memCache = 2048;
            break;
        case G_MEMORY_CACHE_LARGE:
            config->memCache = 4096;
            break;
        default:
            break;
        }
        //config->memCache = size;
    //    write_config();
    //    if (!automatic)
    //        if (!gtk_webcore_preference_set_int ("browser.cache.memory.capacity", config->memCache))
    //            g_webcore_web_show_memory_cache_error ("Error! It was not possible to set the cache size.");*/
}

static GMemoryCache
g_webcore_web_get_memory_cache (GWebcoreWeb *self)
{
    /*    if (!gtk_webcore_preference_get_int ("browser.cache.memory.capacity", &config->memCache))
            g_webcore_web_show_memory_cache_error ("Error! It was not possible to get the cache size.");
     
        switch (config->memCache)
        {
        case 0:
            return G_MEMORY_CACHE_OFF;
            break;
        case 512:
            return G_MEMORY_CACHE_SMALL;
            break;
        case 1024:
            return G_MEMORY_CACHE_MEDIUM;
            break;
        case 2048:
            return G_MEMORY_CACHE_DEFAULT;
            break;
        case 4096:
            return G_MEMORY_CACHE_LARGE;
            break;
        default:
            config->memCache = 256;
    */        return G_MEMORY_CACHE_AUTOMATIC;
    /*        break;
        }
    */
}

#define MAXIMUM_GLOBAL_HISTORY 50
static void
g_webcore_web_reset_cache_history_length (GWebcoreWeb *self)
{
    return;
}

static GWebStatus
g_webcore_web_set_cache_size (GWebcoreWeb *self, gint size)
{
    //    if (gtk_webcore_preference_set_int ("browser.cache.memory.capacity", config->memCache))
    //        return (GWebStatus)FALSE;
    //    else
    return (GWebStatus)TRUE;
}

static gint
g_webcore_web_get_cache_size (GWebcoreWeb *self)
{
    //    if (gtk_webcore_preference_get_int ("browser.cache.memory.capacity", &config->memCache))
    //        return config->memCache;
    //    else
    return -1;
}

static GWebStatus
g_webcore_web_set_browse_offline (GWebcoreWeb *self, gboolean offline)
{
    //    if (gtk_webcore_preference_set_boolean("network.online",offline))
    //    {
    //        if (offline)
    //            g_print("[OFFLINE] Webcore is online\n");
    //        else
    //            g_print("[OFFLINE] Webcore is offline\n");
    //        return (GWebStatus)TRUE;
    //    }
    //    else
    return (GWebStatus)FALSE;
}

static gboolean
g_webcore_web_get_browse_offline (GWebcoreWeb *self)
{
    gboolean offline=TRUE;  //Webcore is online
    //    gtk_webcore_preference_get_boolean("network.online",&offline);
    return offline;
}

static GWebStatus
g_webcore_web_set_automatic_redirection_enabled (GWebcoreWeb *self, gboolean enabled)
{
    //return (GWebStatus) gtk_webcore_prefs_set_int(PREF_CLIENT_PULL_ENABLED, (gint) enabled);
}

static gboolean
g_webcore_web_get_automatic_redirection_enabled (GWebcoreWeb *self)
{/*
                                        gint enabled=0;
                                        gtk_webcore_prefs_get_int(PREF_CLIENT_PULL_ENABLED, &enabled);
                                        return (gboolean) enabled;*/
}

void
g_webcore_web_set_load_images (GWebcoreWeb *self, GWebEngineImagePolicy level)
{
    /*    switch (level)
        {
        case G_WEBENGINE_POLICY_NO_IMAGES:
            config->loadImages=2;
            break;
        case G_WEBENGINE_POLICY_LOADED_IMAGES:
            config->loadImages=1;
            break;
        case G_WEBENGINE_POLICY_ALL_IMAGES:
            config->loadImages=0;
            break;
        }
        write_config();*/
}

static GWebEngineImagePolicy
g_webcore_web_get_load_images (GWebcoreWeb *self)
{
    /*    switch (config->loadImages)
        {
        case 0:
            return G_WEBENGINE_POLICY_ALL_IMAGES;
            break;
        case 1:
            return G_WEBENGINE_POLICY_LOADED_IMAGES;
            break;
        case 2:
            return G_WEBENGINE_POLICY_NO_IMAGES;
            break;
        default:*/
    return G_WEBENGINE_POLICY_ALL_IMAGES;
    //    }
}

static void
g_webcore_web_disconnect (GWebcoreWeb *self)
{}

static GWebStatus
g_webcore_web_clear_cache (GWebcoreWeb *self)
{
    //guint diskCache = 2;
    //    guint memoryCache = 1;
    return (GWebStatus) TRUE;
    //gtk_webcore_clear_cache(memoryCache);
}

static GWebPluginList*
g_webcore_web_get_plugins_list (GWebcoreWeb *self)
{
    return G_WEB_PLUGIN_LIST(g_webcore_plugin_list_new());
}

static GWebHistoryList*
g_webcore_web_get_history_list (GWebcoreWeb *self)
{
    return G_WEB_HISTORY_LIST(g_webcore_history_list_new ());
}

static GWebStatus
g_webcore_web_set_new_window_loads (GWebcoreWeb *self, gboolean loads)
{
    //return (GWebStatus) gtk_webcore_prefs_set_application_int("Load Home Page", (gint) loads);
}

static gboolean
g_webcore_web_get_new_window_loads (GWebcoreWeb *self)
{}

static void
g_webcore_web_set_cookie_acceptance (GWebcoreWeb *self, GCookieAcceptance acceptance)
{
    /*    gint confirm    = 0;
        gint mode       = 3;
        gint path_err   = 1;
        gint session    = 0;*/
    /*
        if (gtk_webcore_preference_set_int ("network.cookie.cookieBehavior", (gint) acceptance) != G_WEB_STATUS_OK)
        {
            g_webcore_web_show_error("Error! Cookie acceptance settings failed.");
        }
     
        switch (acceptance)
        {
        case G_ACCEPT_COOKIE_ALWAYS:
            session   = 1;
            break;
        case G_ACCEPT_COOKIE_NEVER:
            mode      = 0;
            break;
        default:
            confirm   = 1;
            path_err  = 0;
            break;
        }
     
        if (gtk_webcore_preference_set_int(G_WEB_SIGNAL_ASK_COOKIE          , confirm  ) != G_WEB_STATUS_OK)
        {
            g_webcore_web_show_error("Error! Ask For Cookie Confirmation settings failed.");
        }
     
        if (gtk_webcore_preference_set_int(G_WEB_SIGNAL_ASK_COOKIE         ,   mode     ) != G_WEB_STATUS_OK)
        {
            g_webcore_web_show_error("Error! Enable Cookies mode settings failed");
        }
        if (gtk_webcore_preference_set_int(G_WEB_SIGNAL_ASK_COOKIE, 1        ) != G_WEB_STATUS_OK)
        {
            g_webcore_web_show_error("Error! Do Not Show Cookie Domain Errors settings failed.");
        }
        if (gtk_webcore_preference_set_int(G_WEB_SIGNAL_ASK_COOKIE , path_err ) != G_WEB_STATUS_OK)
        {
            g_webcore_web_show_error("Error! Display warning for cookies with illegal path settings failed.");
        }
        if (gtk_webcore_preference_set_int(G_WEB_SIGNAL_ASK_COOKIE   , session  ) != G_WEB_STATUS_OK)
        {
            g_webcore_web_show_error("Error! Accept cookies only for a session settings failed.");
        }*/
}

static GCookieAcceptance
g_webcore_web_get_cookie_acceptance (GWebcoreWeb *self)
{
    gint cookie_acceptance=0;
    //    cookie_acceptance = gtk_webcore_preference_get_int("network.cookie.cookieBehavior",&cookie_acceptance);

    return (GCookieAcceptance)cookie_acceptance;
}

static GSList*
g_webcore_web_get_cookies_list (GWebcoreWeb *self)
{
    //return G_WEB_COOKIE_LIST(g_webcore_cookie_list_new ());
    return NULL;	//    return  gtk_webcore_get_cookie_list();
}

static void
g_webcore_web_set_popup_acceptance (GWebcoreWeb *self, GPopupAcceptance acceptance)
{
    /*    switch (acceptance)
        {
        case G_ACCEPT_POPUP_ALWAYS:
            config->blockPopups=0;
            break;
        case G_ACCEPT_POPUP_PROMPT:
            // Needs prompt stuff
            config->blockPopups=1;
            GMOZ_LOG_NOT_IMP();
            break;
        case G_ACCEPT_POPUP_NEVER:
            config->blockPopups=1;
            break;
        }
        write_config();*/
}

static GPopupAcceptance
g_webcore_web_get_popup_acceptance (GWebcoreWeb *self)
{

    /*    switch (config->blockPopups)
        {
        case 0:
            return G_ACCEPT_POPUP_ALWAYS;
            break;
        case 1:
            return G_ACCEPT_POPUP_NEVER;
            break;
        default:*/
    return G_ACCEPT_POPUP_ALWAYS;
    //    }
}

static GWebStatus
g_webcore_web_set_language (GWebcoreWeb *self, const gchar* language)
{/*
                                        GWebStatus status = (GWebStatus) gtk_webcore_prefs_commit();    
                                        if (gtk_webcore_web_save_global_history() != GTK_WEBCORE_STATUS_OK) {	    
                                    		g_webcore_web_show_error ("Error! Save global history failed.");	    
                                        }
                                        gtk_webcore_reclaim_memory(TRUE);
                                        gtk_webcore_suspend(TRUE);
                                        return status;*/
}

static gchar*
g_webcore_web_get_language (GWebcoreWeb *self)
{/*
                                        GWebStatus status = (GWebStatus) gtk_webcore_prefs_commit();    
                                        if (gtk_webcore_web_save_global_history() != GTK_WEBCORE_STATUS_OK) {	    
                                    		g_webcore_web_show_error ("Error! Save global history failed.");	    
                                        }
                                        gtk_webcore_reclaim_memory(TRUE);
                                        gtk_webcore_suspend(TRUE); */
    return NULL;
}

static GWebStatus
g_webcore_web_suspend (GWebcoreWeb *self)
{/*
                                        GWebStatus status = (GWebStatus) gtk_webcore_prefs_commit();    
                                        if (gtk_webcore_web_save_global_history() != GTK_WEBCORE_STATUS_OK) {	    
                                    		g_webcore_web_show_error ("Error! Save global history failed.");	    
                                        }
                                        gtk_webcore_reclaim_memory(TRUE);
                                        gtk_webcore_suspend(TRUE);
                                        return status;*/
}

static gboolean
g_webcore_web_suspended (GWebcoreWeb *self)
{}

static void
g_webcore_web_resume (GWebcoreWeb *self)
{
    //gtk_webcore_suspend(FALSE);
}

static void
g_webcore_web_set_ua_string (GWebcoreWeb *self, gchar *ua_string)
{}

static void
g_webcore_web_enable_url_loading (GWebcoreWeb *self, gboolean enable)
{}

static GWebStatus
g_webcore_web_store_transfers (GWebcoreWeb *self)
{}

static GWebStatus
g_webcore_web_restore_transfers (GWebcoreWeb *self)
{}

static GWebStatus
g_webcore_web_delete_all_cookies (GWebcoreWeb *self)
{
    //return G_WEBCORE_COOKIE_LIST(G_WEBCORE_WEB(self)->global);
    //return (GWebStatus)gtk_webcore_web_delete_all_cookies();
    //    GSList *cookiesList = NULL;
    //    cookiesList = gtk_webcore_get_cookie_list();
    return (GWebStatus) TRUE;// gtk_webcore_delete_all_cookies(cookiesList);
}

static GWebStatus
g_webcore_web_confirm_cookie (GWebcoreWeb *self, gpointer context, gboolean accept, GWebCookieAction action)
{
    //return (GWebStatus) gtk_webcore_web_cookie_confirm(context, accept, action);
}

static GObject*
g_webcore_web_get_global (GWebcoreWeb *self)
{
    return G_OBJECT(G_WEBCORE_WEB(self)->global);
}

static GWebCertificateMessage
g_webcore_web_get_certificate_enum_message (GWebcoreWeb *self,
        GObject *context)
{}

static GWebCertificateReaction
g_webcore_web_perform_crtificate_context_action (GWebcoreWeb *self,
        GObject *context,
        GWebCertificateAction action,
        GObject *cert)
{}

static GWebStatus
g_webcore_web_get_certificate_context_iter (GWebcoreWeb *self,
        GObject* context,
        GObject **iterator)
{}

static GObject*
g_webcore_web_get_certificate_iter (GWebcoreWeb *self, GObject** iterator)
{}

static void
g_webcore_web_notify_plugins (GWebcoreWeb *self, gint event)
{}

static void
g_webcore_web_interface_init (GWebIface *iface)
{
    iface->destroy                            = (void (*) (GWeb*))
            g_webcore_web_destroy;
    iface->new_web_engine_window              = (GWebEngine* (*) (GWeb*))
            g_webcore_web_new_web_engine_window;
    iface->new_web_engine_window_with_context = (GWebEngine* (*) (GWeb*, gpointer, gboolean, gboolean))
            g_webcore_web_new_web_engine_window_with_context;
    iface->new_web_transfer_item              = (GWebTransferItem* (*) (GWeb*, const gchar*, const gchar*))
            g_webcore_web_new_web_transfer_item;
    iface->initialize_web_transfer_item       = (GWebTransferItem* (*) (GWeb*, GObject*))
            g_webcore_web_initialize_web_transfer_item;
    iface->get_web_transfer_item_list         = (GWebTransferItemList* (*) (GWeb*))
            g_webcore_web_get_web_transfer_item_list;
    iface->set_home_page                      = (GWebStatus (*) (GWeb*, const gchar*))
            g_webcore_web_set_home_page;
    iface->get_home_page                      = (gchar* (*) (GWeb*))
            g_webcore_web_get_home_page;
    iface->set_language                       = (GWebStatus (*) (GWeb*, const gchar*))
            g_webcore_web_set_language;
    iface->get_language                       = (gchar* (*) (GWeb*))
            g_webcore_web_get_language;
    iface->reset_cache_history_length         = (void (*) (GWeb*))
            g_webcore_web_reset_cache_history_length;
    iface->get_maximum_cache_size             = (gint (*) (GWeb*))
            g_webcore_web_get_maximum_cache_size;
    iface->get_default_home_page              = (gchar* (*) (GWeb*))
            g_webcore_web_get_default_home_page;
    iface->home_page_set                      = (gboolean (*) (GWeb*))
            g_webcore_web_home_page_set;
    iface->set_frame_borders_enabled          = (void (*) (GWeb*, gboolean))
            g_webcore_web_set_frame_borders_enabled;
    iface->get_frame_borders_enabled          = (gboolean (*) (GWeb*))
            g_webcore_web_get_frame_borders_enabled;
    iface->set_location_completion_suffixes   = (GWebStatus (*) (GWeb*, const gchar*))
            g_webcore_web_set_location_completion_suffixes;
    iface->get_location_completion_suffixes   = (gchar* (*) (GWeb*))
            g_webcore_web_get_location_completion_suffixes;
    iface->set_plugins_enabled                = (GWebStatus (*) (GWeb*, gboolean))
            g_webcore_web_set_plugins_enabled;
    iface->set_ssl2_support                   = (GWebStatus (*) (GWeb*, gboolean))
            g_webcore_web_set_ssl2_support;
    iface->get_ssl2_support                   = (gboolean (*) (GWeb*))
            g_webcore_web_get_ssl2_support;
    iface->get_plugins_enabled                = (gboolean (*) (GWeb*))
            g_webcore_web_get_plugins_enabled;
    iface->set_js_enabled                     = (GWebStatus (*) (GWeb*, gboolean))
            g_webcore_web_set_js_enabled;
    iface->get_js_enabled                     = (gboolean (*) (GWeb*))
            g_webcore_web_get_js_enabled;
    iface->set_memory_cache                   = (void (*) (GWeb*, GMemoryCache))
            g_webcore_web_set_memory_cache;
    iface->get_memory_cache                   = (GMemoryCache (*) (GWeb*))
            g_webcore_web_get_memory_cache;
    iface->set_cache_size                     = (GWebStatus (*) (GWeb*, gint))
            g_webcore_web_set_cache_size;
    iface->get_cache_size                     = (gint (*) (GWeb*))
            g_webcore_web_get_cache_size;
    iface->set_browse_offline                 = (GWebStatus (*) (GWeb*, gboolean))
            g_webcore_web_set_browse_offline;
    iface->get_browse_offline                 = (gboolean (*) (GWeb*))
            g_webcore_web_get_browse_offline;
    iface->set_automatic_redirection_enabled  = (GWebStatus (*) (GWeb*, gboolean))
            g_webcore_web_set_automatic_redirection_enabled;
    iface->get_automatic_redirection_enabled  = (gboolean (*) (GWeb*))
            g_webcore_web_get_automatic_redirection_enabled;
    iface->set_load_images                    = (GWebStatus (*) (GWeb*, GWebEngineImagePolicy))
            g_webcore_web_set_load_images;
    iface->get_load_images                    = (GWebEngineImagePolicy (*) (GWeb*))
            g_webcore_web_get_load_images;
    iface->disconnect                         = (void (*) (GWeb*))
            g_webcore_web_disconnect;
    iface->clear_cache                        = (GWebStatus (*) (GWeb*))
            g_webcore_web_clear_cache;
    iface->get_plugins_list                   = (GWebPluginList* (*) (GWeb*))
            g_webcore_web_get_plugins_list;
    iface->get_history_list                   = (GWebHistoryList* (*) (GWeb*))
            g_webcore_web_get_history_list;
    iface->set_new_window_loads               = (GWebStatus (*) (GWeb*, gboolean))
            g_webcore_web_set_new_window_loads;
    iface->get_new_window_loads               = (gboolean (*) (GWeb*))
            g_webcore_web_get_new_window_loads;
    iface->set_cookie_acceptance              = (void (*) (GWeb*, GCookieAcceptance))
            g_webcore_web_set_cookie_acceptance;
    iface->get_cookie_acceptance              = (GCookieAcceptance (*) (GWeb*))
            g_webcore_web_get_cookie_acceptance;
    iface->set_popup_acceptance               = (void (*) (GWeb*, GPopupAcceptance))
            g_webcore_web_set_popup_acceptance;
    iface->get_popup_acceptance               = (GPopupAcceptance (*) (GWeb*))
            g_webcore_web_get_popup_acceptance;
    iface->suspend                            = (GWebStatus (*) (GWeb*))
            g_webcore_web_suspend;
    iface->suspended                          = (gboolean (*) (GWeb*))
            g_webcore_web_suspended;
    iface->resume                             = (void (*) (GWeb*))
            g_webcore_web_resume;
    iface->set_ua_string                      = (void (*) (GWeb*, gchar*))
            g_webcore_web_set_ua_string;
    iface->enable_url_loading                 = (void (*) (GWeb*, gboolean))
            g_webcore_web_enable_url_loading;
    iface->store_transfers                    = (GWebStatus (*) (GWeb*))
            g_webcore_web_store_transfers;
    iface->restore_transfers                  = (GWebStatus (*) (GWeb*))
            g_webcore_web_restore_transfers;
    iface->delete_all_cookies                 = (GWebStatus (*) (GWeb*))
            g_webcore_web_delete_all_cookies;
    iface->confirm_cookie                     = (GWebStatus (*) (GWeb*, gpointer, gboolean, GWebCookieAction))
            g_webcore_web_confirm_cookie;
    iface->get_global                         = (GObject* (*) (GWeb*))
            g_webcore_web_get_global;
    iface->get_certificate_enum_message       = (GWebCertificateMessage (*) (GWeb*, GObject*))
            g_webcore_web_get_certificate_enum_message;
    iface->perform_crtificate_context_action  = (GWebCertificateReaction (*) (GWeb*,
            GObject*,
            GWebCertificateAction,
            GObject*))
            g_webcore_web_perform_crtificate_context_action;
    iface->get_certificate_context_iter       = (GWebStatus (*) (GWeb*, GObject*, GObject**))
            g_webcore_web_get_certificate_context_iter;
    iface->get_certificate_iter               = (GObject* (*) (GWeb*, GObject**))
            g_webcore_web_get_certificate_iter;
    iface->notify_plugins                     = (void (*) (GWeb*, gint))
            g_webcore_web_notify_plugins;
}


static void
g_webcore_web_instance_init (GTypeInstance *instance, gpointer  g_class)
{
    G_WEBCORE_WEB(instance)->global = NULL;
}

GType
g_webcore_web_get_type (void)
{
    static GType type = 0;
    if (type == 0)
    {
        static const GTypeInfo info =
            {
                sizeof (GWebcoreWebClass),
                NULL,   /* base_init */
                NULL,   /* base_finalize */
                NULL,   /* class_init */
                NULL,   /* class_finalize */
                NULL,   /* class_data */
                sizeof (GWebcoreWeb),
                0,      /* n_preallocs */
                g_webcore_web_instance_init    /* instance_init */
            };
        static const GInterfaceInfo iface_info =
            {
                (GInterfaceInitFunc) g_webcore_web_interface_init,
                NULL,   /* interface_finalize */
                NULL    /* interface_data */
            };
        type = g_type_register_static (G_TYPE_OBJECT,
                                       "GWebcoreWeb",
                                       &info, (GTypeFlags) 0);
        g_type_add_interface_static (type,
                                     G_TYPE_WEB,
                                     &iface_info);
    }
    return type;
}

/*GObject*
g_web_new (void)
{
    //    printf("%s, %i\n", __FUNCTION__, __LINE__);
    GObject* instance = G_OBJECT(g_object_new(g_webcore_web_get_type(), NULL));
    G_WEBCORE_WEB(instance)->global = instance;
    //    G_WEBCORE_WEB(instance)->global = g_webcore_engine_new();
    return instance;
}*/


GObject*
g_web_new (void)
{
    GObject* instance = G_OBJECT(g_object_new(g_webcore_web_get_type(), NULL));
    G_WEBCORE_WEB(instance)->global = instance;
    //    G_WEBCORE_WEB(instance)->global = G_OBJECT(gtk_webcore_web_engine_new());

    return instance;

}

void
g_web_set_env (void)
{
    /*    gchar *ld_lib_path = g_strdup_printf("%s:%s", LD_PATH, getenv ("LD_LIBRARY_PATH"));
        gchar *ld_lib_all_path = g_strdup_printf("%s%s:%s", LD_PATH, "/components", LD_PATH);
        setenv("LD_LIBRARY_PATH", ld_lib_path, 0);
        setenv("WEBCORE_FIVE_HOME", LD_PATH, 0);
        setenv("DYLD_LIBRARY_PATH", LD_PATH, 0);
        setenv("LIBRARY_PATH", ld_lib_all_path, 0);
        setenv("SHLIB_PATH", LD_PATH, 0);
        setenv("LIBPATH", LD_PATH, 0);
        setenv("ADDON_PATH", LD_PATH, 0);
        setenv("MOZ_TOOLKIT", "", 0);
        setenv("moz_debug", "", 0);
        setenv("moz_debugger", "", 0);
        g_free(ld_lib_path);
        g_free(ld_lib_all_path);*/
}
